package svlight.web;

import java.net.*;
import java.io.*;
import java.util.*;


class ClientManager extends Thread {

   private ServerSocket mainSock = null;
   private Vector conVec = null;
   private DataOutputStream output = null;
      
   SVWebServer server;
   int port;

   /**
    * constructor
    */
   public ClientManager(SVWebServer server, int port) {
      this.server = server;
      this.port = port;

      try {
        mainSock = new ServerSocket(port);

        conVec = new Vector(5, 2); // connection vector
      } catch(Exception e) { 
        System.err.println("\nCan't create socket for the web client."); 
     }  
   }

   /**
    * read commands from the client and do work
    */
   public void run() {

     // continuously listen the socket
     while (true) {
        try {
           Socket connection = mainSock.accept();

           ClientManagerWorker manager = new ClientManagerWorker(connection, this);
           manager.start();
           conVec.addElement(manager);

           //clean up the vector if needed
           for (int i=0; i<conVec.size(); i++)
              if (!((ClientManagerWorker)(conVec.elementAt(i))).isAlive())
                  conVec.removeElementAt(i);

        } catch(Exception e) {
e.printStackTrace();
           System.err.println("Can't accept client's request.");
           return;
        }
     }
   }

  /**
   * kill this server
   */
  public void killServer() {
     try {
        for (int i=0; i<conVec.size(); i++) 
          if (((ClientManagerWorker)(conVec.elementAt(i))).isAlive()) 
             ((ClientManagerWorker)(conVec.elementAt(i))).stop();
        conVec.removeAllElements();
        conVec = null;

        mainSock.close();
     } catch (Exception e) {
e.printStackTrace();
        System.out.println("Socket closing error.");
     }

     stop();
  }


} // end of class ClientManager

