package svlight.web;

import java.net.*;
import java.io.*;
import java.util.*;


class WebManagerWorker extends Thread {
   private Socket sock;
   private DataOutputStream out;
   private DataInputStream in;

   WebManager parent;

   /**
    * constructor
    * @param s server socket
    */
   public WebManagerWorker(Socket s, DataOutputStream out, WebManager parent) {
      sock = s;
      this.out = out;
      this.parent = parent;
   }

   /**
    * read commands from the client and do work
    */
   public void run() {
      try {
	in  = new DataInputStream(new BufferedInputStream(sock.getInputStream()));
        String hostname = sock.getInetAddress().getHostName();
        int command = in.readInt();

        /////////////////////////////////////////////////////////////////
        // Now we have to decide what commands and data are received 
        // from the client. Normally, after receiving data, connection will
        // be disconnected. 

        doServerWork(hostname, command); // do the server work
        sock.close();                    // close the socket

      } catch (Exception e) {
	e.printStackTrace();
      }
      stop();
   }

   //////////////////////////////////////////////////////////////
   // receive the confirm message
   private void doCommand_0(String hostname) {
     try {     
       out.writeUTF("ok");
       out.flush();
     } catch (Exception e) {
        System.out.println("Data receiving/sending error(0).");
        return;
     }
   }


   //////////////////////////////////////////////////////////////
   // for java_ser
   private void doCommand_10(String hostname) {
System.out.println("doCommand_10");
      try {
         int size = in.readInt();
System.out.println(size);
         byte[] titlechars = new byte[size];
         in.read(titlechars, 0, size);

         float time = in.readFloat();
         int nx = in.readInt();

         float[] xArr = new float[nx];
         float[] yArr = new float[nx];

         for (int j=0; j<nx; j++) {
            xArr[j] = in.readFloat();
            yArr[j] = in.readFloat();
System.out.println(xArr[j] + " " + yArr[j]);
         }

         out.writeInt(10);
         out.writeInt(size);
         out.write(titlechars, 0, size);
         out.writeFloat(time);
         out.writeInt(nx);

         for (int j=0; j<nx; j++) {
            out.writeFloat(xArr[j]);
            out.writeFloat(yArr[j]);
         }

      } catch (Exception e) {
e.printStackTrace();
         System.out.println("Data receiving/sending error(10).");
         return;
      }

   }

    
   // real worker
   private synchronized void doServerWork(String hostname, int command) {
     switch(command) {
        case 0:  doCommand_0(hostname);   break;
        case 10:  doCommand_10(hostname);   break;
     }
   }

} // end of class WebManagerWorker






